'use strict';

var _regeneratorRuntime = require('babel-runtime/regenerator')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _pg = require('pg');

var _pg2 = _interopRequireDefault(_pg);

var _querybox = require('querybox');

var _querybox2 = _interopRequireDefault(_querybox);

exports['default'] = function (connStr, pathToSQLFiles) {
  var _this = this;

  var db = {
    pg: _pg2['default'],

    getClient: function getClient() {
      return new _bluebird2['default'](function (resolve, reject) {
        _pg2['default'].connect(connStr, function (error, client, done) {
          client.done = done;

          if (error) return reject(error);
          return resolve(client);
        });
      });
    },

    query: function query(client, text, vals) {
      return _regeneratorRuntime.async(function query$(context$2$0) {
        while (1) switch (context$2$0.prev = context$2$0.next) {
          case 0:
            if (!(!client || typeof client.query !== 'function')) {
              context$2$0.next = 6;
              break;
            }

            vals = text;
            text = client;

            context$2$0.next = 5;
            return _regeneratorRuntime.awrap(db.getClient());

          case 5:
            client = context$2$0.sent;

          case 6:
            return context$2$0.abrupt('return', new _bluebird2['default'](function (resolve, reject) {
              client.query(text, vals, function (error, result) {
                client.done();
                if (error) return reject(error);
                return resolve(result.rows);
              });
            }));

          case 7:
          case 'end':
            return context$2$0.stop();
        }
      }, null, _this);
    },

    one: function one(client, text, vals) {
      var rows;
      return _regeneratorRuntime.async(function one$(context$2$0) {
        while (1) switch (context$2$0.prev = context$2$0.next) {
          case 0:
            context$2$0.next = 2;
            return _regeneratorRuntime.awrap(db.query(client, text, vals));

          case 2:
            rows = context$2$0.sent;
            return context$2$0.abrupt('return', rows[0]);

          case 4:
          case 'end':
            return context$2$0.stop();
        }
      }, null, _this);
    }
  };

  if (!pathToSQLFiles) return db;

  var sqlPath = pathToSQLFiles;
  var box = (0, _querybox2['default'])(sqlPath, function callee$1$0(text, vals, callback) {
    return _regeneratorRuntime.async(function callee$1$0$(context$2$0) {
      while (1) switch (context$2$0.prev = context$2$0.next) {
        case 0:
          context$2$0.prev = 0;
          context$2$0.next = 3;
          return _regeneratorRuntime.awrap(db.query(text, vals));

        case 3:
          rows = context$2$0.sent;
          return context$2$0.abrupt('return', callback(null, rows));

        case 7:
          context$2$0.prev = 7;
          context$2$0.t0 = context$2$0['catch'](0);
          return context$2$0.abrupt('return', callback(context$2$0.t0));

        case 10:
        case 'end':
          return context$2$0.stop();
      }
    }, null, this, [[0, 7]]);
  });

  db.run = function callee$1$0(client, name, vals) {
    var queryFn;
    return _regeneratorRuntime.async(function callee$1$0$(context$2$0) {
      while (1) switch (context$2$0.prev = context$2$0.next) {
        case 0:
          if (!(!client || typeof client.query !== 'function')) {
            context$2$0.next = 6;
            break;
          }

          vals = name;
          name = client;
          context$2$0.next = 5;
          return _regeneratorRuntime.awrap(db.getClient());

        case 5:
          client = context$2$0.sent;

        case 6:
          queryFn = client.query.bind(client);
          return context$2$0.abrupt('return', new _bluebird2['default'](function (resolve, reject) {
            box._run(queryFn, name, vals, function (error, result) {
              client.done();
              if (error) return reject(error);
              return resolve(result.rows);
            });
          }));

        case 8:
        case 'end':
          return context$2$0.stop();
      }
    }, null, _this);
  };

  db.first = function callee$1$0(client, name, vals) {
    return _regeneratorRuntime.async(function callee$1$0$(context$2$0) {
      while (1) switch (context$2$0.prev = context$2$0.next) {
        case 0:
          context$2$0.next = 2;
          return _regeneratorRuntime.awrap(db.run(client, name, vals));

        case 2:
          return context$2$0.abrupt('return', context$2$0.sent[0]);

        case 3:
        case 'end':
          return context$2$0.stop();
      }
    }, null, _this);
  };

  return db;
};

module.exports = exports['default'];